Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.w3c.dom
Interface Node

All Known Subinterfaces:
  Attr, CauchoDocument, CauchoElement, CauchoNode, CDATASection, CharacterData, Comment, Document, DocumentFragment, DocumentType, Element, Entity, EntityReference, Notation, ProcessingInstruction, Text

public interface Node

The `Node` interface is the primary datatype for the entire Document Object Model. It represents a single node in the document tree. While all objects implementing the `Node` interface expose methods for dealing with children, not all objects implementing the `Node` interface may have children. For example, `Text` nodes may not have children, and adding children to such nodes results in a `DOMException` being raised.

The attributes `nodeName`, `nodeValue` and `attributes` are included as a mechanism to get at node information without casting down to the specific derived interface. In cases where there is no obvious mapping of these attributes for a specific `nodeType` (e.g., `nodeValue` for an Element or `attributes` for a Comment), this returns `null`. Note that the specialized interfaces may contain additional and more convenient mechanisms to get and set the relevant information.

Field Summary
`static short` | `ATTRIBUTE_NODE`
`static short` | `CDATA_SECTION_NODE`
`static short` | `COMMENT_NODE`
`static short` | `DOCUMENT_FRAGMENT_NODE`
`static short` | `DOCUMENT_NODE`
`static short` | `DOCUMENT_TYPE_NODE`
`static short` | `ELEMENT_NODE`
`static short` | `ENTITY_NODE`
`static short` | `ENTITY_REFERENCE_NODE`
`static short` | `NOTATION_NODE`
`static short` | `PROCESSING_INSTRUCTION_NODE`
`static short` | `TEXT_NODE`

Method Summary
`Node` | `appendChild(Node newChild)` Adds the node `newChild` to the end of the list of children of this node.
`Node` | `cloneNode(boolean deep)` Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
`NamedNodeMap` | `getAttributes()` A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
`NodeList` | `getChildNodes()` A `NodeList` that contains all children of this node.
`Node` | `getFirstChild()` The first child of this node.
`Node` | `getLastChild()` The last child of this node.
`Node` | `getNextSibling()` The node immediately following this node.
`java.lang.String` | `getNodeName()` The name of this node, depending on its type; see the table above.
`short` | `getNodeType()` A code representing the type of the underlying object, as defined above.
`java.lang.String` | `getNodeValue()` The value of this node, depending on its type; see the table above.
`Document` | `getOwnerDocument()` The `Document` object associated with this node.
`Node` | `getParentNode()` The parent of this node.
`Node` | `getPreviousSibling()` The node immediately preceding this node.
`boolean` | `hasChildNodes()` This is a convenience method to allow easy determination of whether a node has any children.
`Node` | `insertBefore(Node newChild, Node refChild)` Inserts the node `newChild` before the existing child node `refChild`.
`Node` | `removeChild(Node oldChild)` Removes the child node indicated by `oldChild` from the list of children, and returns it.
`Node` | `replaceChild(Node newChild, Node oldChild)` Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
`void` | `setNodeValue(java.lang.String nodeValue)`

Field Detail

### ELEMENT_NODE

    public static final short ELEMENT_NODE

### ATTRIBUTE_NODE

    public static final short ATTRIBUTE_NODE

### TEXT_NODE

    public static final short TEXT_NODE

### CDATA_SECTION_NODE

    public static final short CDATA_SECTION_NODE

### ENTITY_REFERENCE_NODE

    public static final short ENTITY_REFERENCE_NODE

### ENTITY_NODE

    public static final short ENTITY_NODE

### PROCESSING_INSTRUCTION_NODE

    public static final short PROCESSING_INSTRUCTION_NODE

### COMMENT_NODE

    public static final short COMMENT_NODE

### DOCUMENT_NODE

    public static final short DOCUMENT_NODE

### DOCUMENT_TYPE_NODE

    public static final short DOCUMENT_TYPE_NODE

### DOCUMENT_FRAGMENT_NODE

    public static final short DOCUMENT_FRAGMENT_NODE

### NOTATION_NODE

    public static final short NOTATION_NODE

Method Detail

### getNodeName

    public java.lang.String getNodeName()

  The name of this node, depending on its type; see the table above.

### getNodeValue

    public java.lang.String getNodeValue()
                                  throws DOMException

  The value of this node, depending on its type; see the table above.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
    `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

### setNodeValue

    public void setNodeValue(java.lang.String nodeValue)
                      throws DOMException

### getNodeType

    public short getNodeType()

  A code representing the type of the underlying object, as defined above.

### getParentNode

    public Node getParentNode()

  The parent of this node. All nodes, except `Document`, `DocumentFragment`, and `Attr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, this is `null`.

### getChildNodes

    public NodeList getChildNodes()

  A `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes. The content of the returned `NodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `NodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `NodeList`, including the ones returned by the `getElementsByTagName` method.

### getFirstChild

    public Node getFirstChild()

  The first child of this node. If there is no such node, this returns `null`.

### getLastChild

    public Node getLastChild()

  The last child of this node. If there is no such node, this returns `null`.

### getPreviousSibling

    public Node getPreviousSibling()

  The node immediately preceding this node. If there is no such node, this returns `null`.

### getNextSibling

    public Node getNextSibling()

  The node immediately following this node. If there is no such node, this returns `null`.

### getAttributes

    public NamedNodeMap getAttributes()

  A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.

### getOwnerDocument

    public Document getOwnerDocument()

  The `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` this is `null`.

### insertBefore

    public Node insertBefore(Node newChild,
                             Node refChild)
                      throws DOMException

  Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children.
  If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed.
  Parameters:
    `newChild` - The node to insert.
    `refChild` - The reference node, i.e., the node before which the new node must be inserted.
  Returns:
    The node being inserted.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to insert is one of this node's ancestors.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if `refChild` is not a child of this node.

### replaceChild

    public Node replaceChild(Node newChild,
                             Node oldChild)
                      throws DOMException

  Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. If the `newChild` is already in the tree, it is first removed.
  Parameters:
    `newChild` - The new node to put in the child list.
    `oldChild` - The node being replaced in the list.
  Returns:
    The node replaced.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or it the node to put in is one of this node's ancestors.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

### removeChild

    public Node removeChild(Node oldChild)
                     throws DOMException

  Removes the child node indicated by `oldChild` from the list of children, and returns it.
  Parameters:
    `oldChild` - The node being removed.
  Returns:
    The node removed.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

### appendChild

    public Node appendChild(Node newChild)
                     throws DOMException

  Adds the node `newChild` to the end of the list of children of this node. If the `newChild` is already in the tree, it is first removed.
  Parameters:
    `newChild` - The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node
  Returns:
    The node added.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to append is one of this node's ancestors.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

### hasChildNodes

    public boolean hasChildNodes()

  This is a convenience method to allow easy determination of whether a node has any children.
  Returns:
    `true` if the node has any children, `false` if the node has no children.

### cloneNode

    public Node cloneNode(boolean deep)

  Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes. The duplicate node has no parent ( `parentNode` returns `null`.).
  Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node.
  Parameters:
    `deep` - If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
  Returns:
    The duplicate node.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD